package gestorTagsRSSI;

import java.util.ArrayList;

public class CalculadorDistancia {
	
	ArrayList<Integer> PWX;//Potencias de lectores: PWA, PWB, PWC -> RSSI
	ArrayList<Double> dxp;//Distancias de los lectores al Tag: double dap, dbp, dcp;
	
	double[] pos;
	
	public CalculadorDistancia(){
		
		this.pos = new double[6];
		PWX = new ArrayList<Integer>();
		dxp = new ArrayList<Double>();
		
		for (int i = 0; i <= 6; i++) {
			dxp.add(i, 3.4E21);
		}
		
		for (int i = 0; i <= 6; i++) {
			PWX.add(i, 0);
		}
		
	}
		
		
		private double calcPWx(int PWx, boolean esquinas){
			//(metros)
			if(!esquinas){
				if (PWx > 140){
					return  (21486.1874379654 * Math.pow(0.946307568063429,PWx) * 30)/100;
				}else if (PWx < 115){
					return (90171.6857975762 * Math.pow(0.911329724176639,PWx) * 50 + 750)/100;
				}else{
					return (1.08144231166755*Math.pow(10,22) * Math.pow(0.650559437013857,PWx) * 30 + 240)/100;
				}
			}else{
				if (PWx > 140){
					return  (1009803.79945041 * Math.pow(0.921240217305297,PWx) * 50)/100;
				}else{
					return (1.85145265063426*Math.pow(10,-39) * Math.pow(1.95278088305151,PWx) * 50 + 450)/100;
				}
			}
		}
		
		//Potencias o RSSI
		public void setPWx(int x, Integer valor){
			PWX.set(x, valor);
		}
		
		//Distancia al punto P
		public void setdxp(int x, Double valor){
			dxp.set(x, valor);
		}
		
		//Distancias entre lectores
		public static double dimeDistancias (String idClienteA, String idClienteB){
			
			if((idClienteA.equals("D") && idClienteB.equals("F")) || (idClienteA.equals("F") && idClienteB.equals("D"))){
				return 8; 
			}
			
			if((idClienteA.equals("E") && idClienteB.equals("B")) || (idClienteA.equals("B") && idClienteB.equals("E"))){
				return 10; 
			}
			
			if((idClienteA.equals("F") && idClienteB.equals("C")) || (idClienteA.equals("C") && idClienteB.equals("F"))){
				return 22.5; 
			}
			
			if((idClienteA.equals("B") && idClienteB.equals("A")) || (idClienteA.equals("A") && idClienteB.equals("B"))){
				return 22.5; 
			}
			
			if((idClienteA.equals("E") && idClienteB.equals("D")) || (idClienteA.equals("D") && idClienteB.equals("E"))){
				return 15; 
			}
			
			if((idClienteA.equals("F") && idClienteB.equals("B")) || (idClienteA.equals("B") && idClienteB.equals("F"))){
				return 12.5; 
			}
			
			if((idClienteA.equals("A") && idClienteB.equals("C")) || (idClienteA.equals("C") && idClienteB.equals("A"))){
				return 13.5; 
			}
			
			if((idClienteA.equals("E") && idClienteB.equals("F")) || (idClienteA.equals("F") && idClienteB.equals("E"))){
				return 17.5; 
			}
			
			if((idClienteA.equals("D") && idClienteB.equals("B")) || (idClienteA.equals("B") && idClienteB.equals("D"))){
				return 15.5; 
			}
			
			if((idClienteA.equals("B") && idClienteB.equals("C")) || (idClienteA.equals("C") && idClienteB.equals("B"))){
				return 25.5; 
			}
			
			if((idClienteA.equals("E") && idClienteB.equals("C")) || (idClienteA.equals("C") && idClienteB.equals("E"))){
				return 26; 
			}
			
			return 32;
		}
		
		public double[] calcula(ArrayList<RFIDclienteProxy> losLectoresActivos){
			double h = 0, i = 0, j = 0;
			double x=0, y=0, z=0;
			int lectores = losLectoresActivos.size();
			
			String[] lectoresActivosSorted = new String[lectores+1];
			for(RFIDclienteProxy t : losLectoresActivos){
				lectoresActivosSorted[t.getImportanciaCliente()] = t.getIDcliente();
			}

			boolean especialEsquinas = false;
			
			if(lectoresActivosSorted[1] != null ){
				if(lectoresActivosSorted[1].equals("A") || lectoresActivosSorted[1].equals("C")){
					especialEsquinas = true;
				}
			}
			
			//Primero, hallamos distancias
			for (int l=1; l <= lectores; l++){
				setdxp(l, calcPWx(PWX.get(l), especialEsquinas));
			}
			
			System.out.println("Lectores " + lectores);
			
			//Segundo, calculamos coordenadas
			switch (lectores) {
			
			case 1:
				
				x = dxp.get(1);
				
				break;
				
			case 2:
				if(lectoresActivosSorted[1] != null && lectoresActivosSorted[2] != null){
					h= dimeDistancias(losLectoresActivos.get(0).getIDcliente(), losLectoresActivos.get(1).getIDcliente());
					System.out.println("h " + h);
					x = ((dxp.get(1)*dxp.get(1)) - (dxp.get(2)*dxp.get(2)) + (h*h))/(2*h);
					y =(dxp.get(2)*dxp.get(2))-((x-h)*(x-h));
					
					if(y < 0 ){
						y=0;
					}else{
						y = Math.sqrt(y);
					}
				}
				break;
			
			case 3:
				if(lectoresActivosSorted[1] != null && lectoresActivosSorted[2] != null && lectoresActivosSorted[3] != null){
			
					//ABC
					if(lectoresActivosSorted[1].equals("A")){
						if(lectoresActivosSorted[2].equals("B")){
							h = 22.5; //distancia de A a B(m)
							i = 13.5; //distancia de A a C (en Y)
							j = 2.5; //distancia de A a C (en X)
						}
					}
					
					//BDF BCF(...)
					if(lectoresActivosSorted[1].equals("B")){
						if(lectoresActivosSorted[2].equals("D")){
							h = 15.5; //distancia de A a B(m)
							i = 6; //distancia de A a C (en Y)
							j = 11.5; //distancia de A a C (en X)
						}
					}
					
					//CFA
					if(lectoresActivosSorted[1].equals("C")){
						if(lectoresActivosSorted[2].equals("F")){
							h = 23.5; //distancia de A a B(m)
							i = 14; //distancia de A a C (en Y)
							j = 1; //distancia de A a C (en X)
						}
					}
					
					//DBE DBC
					if(lectoresActivosSorted[1].equals("D")){
						if(lectoresActivosSorted[2].equals("B")){
							if(lectoresActivosSorted[3].equals("E")){
								h = 15.5; //distancia de A a B(m)
								i = 9.5; //distancia de A a C (en Y)
								j = 10.5; //distancia de A a C (en X)
							}
							if(lectoresActivosSorted[3].equals("C")){
								h = 15.5; //distancia de A a B(m)
								i = 31; //distancia de A a C (en Y)
								j = 1; //distancia de A a C (en X)
							}
						}
					}
					
					//EDF EBD(...) ECB ECD
					if(lectoresActivosSorted[1].equals("E")){
						if(lectoresActivosSorted[2].equals("D")){
							h = 15; //distancia de A a B(m)
							i = 7.5; //distancia de A a C (en Y)
							j = 16; //distancia de A a C (en X)
						}else if(lectoresActivosSorted[2].equals("C")){
							if(lectoresActivosSorted[3].equals("B")){
								h = 34.5; //distancia de A a B(m)
								i = 2.5; //distancia de A a C (en Y)
								j = 10; //distancia de A a C (en X)
							}
							if(lectoresActivosSorted[3].equals("D")){
								h = 34.5; //distancia de A a B(m)
								i = 13; //distancia de A a C (en Y)
								j = 8; //distancia de A a C (en X)
							}
						}
					}
					
					//FCB FBE
					if(lectoresActivosSorted[1].equals("F")){
						if(lectoresActivosSorted[2].equals("C")){
							h = 23; //distancia de A a B(m)
							i = 12.5; //distancia de A a C (en Y)
							j = 1; //distancia de A a C (en X)
						}
						if(lectoresActivosSorted[2].equals("B")){
							h = 12.5; //distancia de A a B(m)
							i = 10; //distancia de A a C (en Y)
							j = 13.5; //distancia de A a C (en X)							
						}
					}

				x = ((dxp.get(1)*dxp.get(1)) - (dxp.get(2)*dxp.get(2)) + (h*h))/(2*h);
				y = (((dxp.get(1)*dxp.get(1)) - (dxp.get(3)*dxp.get(3)) + (i*i) + (j*j))/(2*j))-((i/j)*x);
				z = (dxp.get(1)*dxp.get(1))-(x*x)-(y*y);
				
				if(z < 0 ){
					z=0;
				}else{
					z = Math.sqrt(z);
				}
				
				}
				break;

			}
			
			//this.pos[0] = x;
			//this.pos[1] = y;
			//this.pos[2] = z;
			
			System.out.println("RSSIs " + PWX.get(1) + " " + PWX.get(2) +  " " + PWX.get(3));
			System.out.println("Distancias " + dxp.get(1) + " " + dxp.get(2) +  " " + dxp.get(3));
			
			this.pos[0] = x;
			this.pos[1] = y;
			this.pos[2] = z;
			
/*			for(RFIDclienteProxy t : losLectoresActivos){
				if(t.getImportanciaCliente() == 1){
					posicionGlobal(pos, t.getCoordenadas());
				}
			}*/

			return pos;
			
		}


		public void posicionGlobal(double[] pos, int[] posLectorPrincipal) {
			//this.pos[3] = 
			//this.pos[4] = 
			//this.pos[5] = 
		}
	
	

}
