package gestorTagsRSSI;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class RFIDclienteProxy implements Runnable {

	static Thread th;
	private BufferedReader inFromClient;
	private PrintWriter outToClient;
	private Socket connectionSocket;
	private String IDcliente;
	private Gestor elGestor;
	int[] coordenadas = {0,0,0};
	Tag tagLeida = null;
	
	private int ImportanciaCliente;
	private int RSSI;

	public RFIDclienteProxy(Socket con, Gestor gestor) {
		this.connectionSocket = con;
		this.elGestor = gestor;
		try{

			inFromClient = new BufferedReader(new InputStreamReader(
					connectionSocket.getInputStream()));

			outToClient = new PrintWriter(connectionSocket.getOutputStream());
			
			th = new Thread (this);
			th.start();

		}catch (IOException e){
			e.printStackTrace();
		}
	}	
	
	public void run() {   	 
		try { 
			int STX = 0x01;
			char INS = 'C';
			int BCC = (STX ^ INS);
			int END = 0x0D;

			String clientSentence;

			while(true){

				System.out.println("Enviando a " + IDcliente + ": " + (INS) + (BCC) + (END));

				outToClient.write(INS);
				outToClient.write(BCC);
				outToClient.write(END);

				outToClient.flush();

				Thread.sleep(3000);// 1000 milliseconds is one second.

				clientSentence = inFromClient.readLine();
				System.out.println("Recibido de " + IDcliente + ": " + clientSentence);
				
				//Longitud valida de clientSentence
				if (clientSentence.length()>=22){
				
					String id = clientSentence.substring(9,17);
					
					elGestor.anyadeTag(new Tag(id));
					
					tagLeida = elGestor.buscaTag(id);
					
						if (clientSentence.length()==23){
							tagLeida.anyadeLectorActivo(this);
							this.RSSI = Integer.parseInt(clientSentence.substring(17,19), 16);
							this.setImportanciaCliente(tagLeida.getImportanciaLector(this.IDcliente));
							tagLeida.setRSSI(ImportanciaCliente, this.RSSI);
							tagLeida.setPos(tagLeida.getnumLectoresActivos());
						}else if (clientSentence.length()==22){
							tagLeida.anyadeLectorActivo(this);
							this.RSSI = Integer.parseInt(clientSentence.substring(16,18), 16);
							this.setImportanciaCliente(tagLeida.getImportanciaLector(this.IDcliente));
							tagLeida.setRSSI(ImportanciaCliente, this.RSSI);
							tagLeida.setPos(tagLeida.getnumLectoresActivos());
						}
						
					}else{
						//Cuando Lectura no valida
						if(tagLeida!=null){
							System.out.println("Yo, " + IDcliente + " me elimino de " + tagLeida.getTagID());
							tagLeida.eliminaLectorActivo(IDcliente);
							tagLeida = null;
						}
					}
				
			}//end While

		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public String getIDcliente() {
		return IDcliente;
	}

	public void setIDcliente(String iDcliente) {
		IDcliente = iDcliente;
	}

	public int getImportanciaCliente() {
		return ImportanciaCliente;
	}

	public void setImportanciaCliente(int importanciaCliente) {
		ImportanciaCliente = importanciaCliente;
	}

	public int getRSSI() {
		return RSSI;
	}

	public void setRSSI(int rSSI) {
		RSSI = rSSI;
	}
	
	public int[] getCoordenadas() {
		return coordenadas;
	}

	public void setCoordenadas(int x, int y, int z) {
		this.coordenadas[0] = x;
		this.coordenadas[1] = y;
		this.coordenadas[2] = z;
	}

}
