package gestorTagsRSSI;

import java.util.ArrayList;

public class Tag {
	
	private String tagID;
	
	private CalculadorDistancia dis;
	
	private ArrayList<RFIDclienteProxy> losLectoresActivos;

	private double[] pos;
	
	public Tag (String ID){
		tagID = ID;
		dis = new CalculadorDistancia();
		//Lista de Lectores Activos (que reciben senyal valida del Tag)
		losLectoresActivos = new ArrayList<RFIDclienteProxy>();
	}

	public double[] getPos() {
		return pos;
	}

	public void setPos(int lectores) {
		this.pos = dis.calcula(losLectoresActivos);
		lectoresActivosPrint();
		System.out.println("Posicion del Tag " + tagID + ": x=" + pos[0] + " y=" + pos[1] + " z=" + pos[2]);
		//System.out.println("Posicion Global " + tagID + ": x=" + pos[3] + " y=" + pos[4] + " z=" + pos[5]);
	}

	public String getTagID() {
		return tagID;
	}
	
	public void setRSSI(int IDLector, Integer valor){
		dis.setPWx(IDLector, valor);
	}
	
	public RFIDclienteProxy buscaLector(String ID){
		if(getnumLectoresActivos() != 0){
			for(RFIDclienteProxy t : losLectoresActivos){
				if(ID.equals(t.getIDcliente())){
					return t;
				}
			}
		}
		return null;		
	}
	
	public void anyadeLectorActivo(RFIDclienteProxy lector){
		if(buscaLector(lector.getIDcliente())==null){
			losLectoresActivos.add(lector);			
		}
	}
	
	public void eliminaLectorActivo(String ID){
		RFIDclienteProxy t = buscaLector(ID);
		if(t!=null){
			losLectoresActivos.remove(t);
		}
	}
	
	public int getnumLectoresActivos(){
		return losLectoresActivos.size();
	}
	
	public int comparaRSSI(int rSSI){
		//cuantos RSSI mayores a rSSI
		int cont = 1;
		if(getnumLectoresActivos() != 0){
			for(RFIDclienteProxy t : losLectoresActivos){
				if(t.getRSSI() > rSSI){
					cont++;
				}
			}
		}
		return cont;
	}
	
	public void lectoresActivosPrint(){
		if(getnumLectoresActivos() != 0){
			for(RFIDclienteProxy t : losLectoresActivos){
				System.out.println(t.getIDcliente() + " " + t.getImportanciaCliente());
			}
		}
	}
	
	public RFIDclienteProxy buscaLectorRSSIMinimo(){
		RFIDclienteProxy Lminimo = null;
		if(getnumLectoresActivos() != 0){
			int min = 200;
			for(RFIDclienteProxy t : losLectoresActivos){
				if(t.getRSSI() < min){
					min = t.getRSSI();
					Lminimo = t;
				}
			}
		}
		return Lminimo;
	}
	
	public RFIDclienteProxy buscaLectorRSSIMaximo(){
		RFIDclienteProxy Lmaximo = null;
		if(getnumLectoresActivos() != 0){
			int max = 0;
			for(RFIDclienteProxy t : losLectoresActivos){
				if(t.getRSSI() > max){
					max = t.getRSSI();
					Lmaximo = t;
				}
			}
		}
		return Lmaximo;
	}
	
	//Asignacion de roles
	public int getImportanciaLector(String iDcliente) {
		
		//ABC
		if (buscaLector("A") != null && buscaLector("B") != null && buscaLector("C") != null){
			if (iDcliente.equals("A")){
				return 1;
			}
			if (iDcliente.equals("B")){
				return 2;
			}
			if (iDcliente.equals("C")){
				return 3;
			}
		
		//BDF
		}else if (buscaLector("B") != null && buscaLector("F") != null && buscaLector("D") != null){
			if (iDcliente.equals("B")){
				return 1;
			}
			if (iDcliente.equals("D")){
				return 2;
			}
			if (iDcliente.equals("F")){
				return 3;
			}
		
		//CFA
		}else if (buscaLector("C") != null && buscaLector("F") != null && buscaLector("A") != null){
			if (iDcliente.equals("C")){
				return 1;
			}
			if (iDcliente.equals("F")){
				return 2;
			}
			if (iDcliente.equals("A")){
				return 3;
			}
			
		//DBE
		}else if (buscaLector("D") != null && buscaLector("B") != null && buscaLector("E") != null){
			if (iDcliente.equals("D")){
				return 1;
			}
			if (iDcliente.equals("B")){
				return 2;
			}
			if (iDcliente.equals("E")){
				return 3;
			}
		//DBC
		}else if (buscaLector("D") != null && buscaLector("B") != null && buscaLector("C") != null){
			if (iDcliente.equals("D")){
				return 1;
			}
			if (iDcliente.equals("B")){
				return 2;
			}
			if (iDcliente.equals("C")){
				return 3;
			}
			
		//EDF
		}else if (buscaLector("E") != null && buscaLector("F") != null && buscaLector("D") != null){
			if (iDcliente.equals("E")){
				return 1;
			}
			if (iDcliente.equals("D")){
				return 2;
			}
			if (iDcliente.equals("F")){
				return 3;
			}

		//ECB
		}else if (buscaLector("E") != null && buscaLector("C") != null && buscaLector("B") != null){
			if (iDcliente.equals("E")){
				return 1;
			}
			if (iDcliente.equals("C")){
				return 2;
			}
			if (iDcliente.equals("B")){
				return 3;
			}
		//ECD
		}else if (buscaLector("E") != null && buscaLector("C") != null && buscaLector("D") != null){
			if (iDcliente.equals("E")){
				return 1;
			}
			if (iDcliente.equals("C")){
				return 2;
			}
			if (iDcliente.equals("D")){
				return 3;
			}
		//FCB
		}else if (buscaLector("F") != null && buscaLector("C") != null && buscaLector("B") != null){
			if (iDcliente.equals("F")){
				return 1;
			}
			if (iDcliente.equals("C")){
				return 2;
			}
			if (iDcliente.equals("B")){
				return 3;
			}
		//FBE
		}else if (buscaLector("F") != null && buscaLector("B") != null && buscaLector("E") != null){
			if (iDcliente.equals("F")){
				return 1;
			}
			if (iDcliente.equals("B")){
				return 2;
			}
			if (iDcliente.equals("E")){
				return 3;
			}

		}else{
			return comparaRSSI(buscaLector(iDcliente).getRSSI());				
			}
		eliminaLectorActivo(iDcliente);
		return 0;
	}
	
	
	
}
